



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Understanding ABI Files</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Understanding ABI Files</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-18 03:07:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>【<strong>Understanding ABI Files</strong>】</p>
<p>　　ABI files can be generated using the&nbsp;<code>eosio-cpp</code>&nbsp;utility provided by&nbsp;<code>eosio.cdt.&nbsp;</code>The Application Binary Interface (ABI) is a JSON-based description.</p>
<p>1、ABI的基本结构</p>
<div>
<pre class="prettyprint linenums">{<br />
   "version": "eosio::abi/1.0",<br />
   "types": [],<br />
   "structs": [],<br />
   "actions": [],<br />
   "tables": [],<br />
   "ricardian_clauses": [],<br />
   "abi_extensions": [],<br />
   "___comment" : ""<br />
}</pre>
</div>
<p>2、types&nbsp;describe the custom types that are used as a parameter in any public action or struct that needs to be described in the ABI.</p>
<p>　　EOSIO implements a number of custom built-ins. <strong>Built-in types don't need to be described in an ABI file</strong>. If you would like to familiarize yourself with EOSIO's built-ins, they are defined&nbsp;<a href="https://github.com/EOSIO/eos/blob/master/libraries/chain/abi_serializer.cpp#L65-L103" rel="external nofollow noreferrer">here</a></p>
<p>　　<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/292994/201811/292994-20181122172008782-1773213763.jpg" /></p>
<p>3、structs</p>
<p>　　action的数据会存在于 structs中。如create action。</p>
<div>
<pre class="prettyprint linenums">{<br />
  "name": "create",<br />
  "base": "",<br />
  "fields": [<br />
    {<br />
      "name":"issuer",<br />
      "type":"name"<br />
    },<br />
    {<br />
      "name":"maximum_supply",<br />
      "type":"asset"<br />
    }<br />
  ]<br />
}</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/292994/201811/292994-20181122172952203-1852638144.jpg" /></p>
<p>　　struct会被写入 structs中。</p>
<div>
<pre class="prettyprint linenums">{<br />
  "name": "currency_stats",<br />
  "base": "",<br />
  "fields": [<br />
    {<br />
      "name":"supply",<br />
      "type":"asset"<br />
    },<br />
    {<br />
      "name":"max_supply",<br />
      "type":"asset"<br />
    },<br />
    {<br />
      "name":"issuer",<br />
      "type":"account_name"<br />
    }<br />
  ]<br />
}</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/292994/201811/292994-20181122173125891-764170153.jpg" /></p>
<p>4、actions</p>
<div>
<pre class="prettyprint linenums">{<br />
  "name": "transfer",             //The name of the action as defined in the contract<br />
  "type": "transfer",             //The name of the implicit struct as described in the ABI<br />
  "ricardian_contract": ""     //An optional ricardian clause to associate to this action describing its intended functionality.<br />
}</pre>
</div>
<p>　　每一个action会隐含(implicit)创建一个struct，通过type来指向。action'name struct'name are not required to be equal.</p>
<p>5、tables</p>
<p>6、Every time you 1)<strong>change a struct</strong>, 2)<strong>add a table</strong>, 3)<strong>add an action</strong> or 4)<strong>add parameters to an action</strong>, 5)<strong>use a new type</strong>, you will need to remember to update your ABI file. In many cases failure to update your ABI file will not produce any error.</p>
<p>7、</p>
<p>参考：</p>
<p>1、<a href="https://developers.eos.io/eosio-home/docs/the-abi" rel="external nofollow noreferrer">https://developers.eos.io/eosio-home/docs/the-abi</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnw442q.html">关于C转汇编（转自网上）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j7gm09.html">WinForm容器内控件批量效验是否允许为空？设置是否只读？设置是否可用等方法分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z51l49.html">【温故知新】C&num;委托delegate</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmd0549.html">sql调用方法精简</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1ry0e9.html">URAL 1353 Milliard Vasya&amp;&num;39&semi;s Function&lpar;DP&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mym0gq.html">Linux&mdash;&mdash;搭建PHP开发环境第三步：mysql</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjwr238.html">DDD理论学习系列（11）-- 工厂</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgw2le8.html">SQLSERVER 远程登录18456错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z2jm39.html">Redis进阶实践之十二 Redis的Cluster集群动态扩容</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj17g39.html">多线程、互斥锁、异步、GIL</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwmnly8.html">423&period; Reconstruct Original Digits from English&lpar;Medium&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwxr548.html">解决centos中vsftpd中文乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jkk03q.html">tensorflow 手写数字识别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ryky58.html">Flask之项目创建&comma;路由以及会话控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r7ox58.html">Matlab-4&colon;追赶法（crout分解）工具箱</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlj2wy9.html">How to Build a Search Page with Elasticsearch and &period;NET</a>
		</li>
						<li><a href="https://www.batexi.com/a/953jnwz8.html">delphi批量存入多媒体字段 遇到内存溢出的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk4mrd8.html">史上最全的Android开发学习教程集锦【初学者】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gprgme9.html">list add&lpar;&rpar;  和 addall&lpar;&rpar;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2g53z8.html">&amp;&num;39&semi;React&sol;RCTBundleURLProvider&period;h&amp;&num;39&semi; file not found</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93w3lkgq.html">&period;net调用系统软键盘（兼容win7及win10）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy6n1mq.html">pam模块初探</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r56pmrq.html">PythonStudy&mdash;&mdash;列表的常用操作  List of common operations</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r56l7mq.html">安装win10 1703版本操作系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjkzdj9.html">JDK8安装与配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1vol49.html">Delphi在调WebService的时候加Soap头验证</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2jyn19.html">laravel框架容器管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy67jgq.html">记一次sql server 2005访问http接口，并解析json的过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw74zd8.html">半分钟学会使用markdown基本语法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1v3rw9.html">记录一下我在lubuntu里面用到的工具</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
